###PERL;

# rmaccess is generated from rmaccess.1.pl.
# 05.01.2016
#
# This script removes old access files.
#
#    Copyright (C) 2015-2016  Balthasar Szczepański
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

###ACCESS_PATH;
###TIMEOUT_UNLOCK;
###TIMEOUT_INACT;

my $time = time();
srand ($time-$$);

my $dir;
my $path;
my $unlocktime;
my $lasttime;
my $timeout_unlock = TIMEOUT_UNLOCK*60;
my $timeout_inact = TIMEOUT_INACT*60;
	
if (opendir ($dir, ACCESS_PATH)) {
	while (defined($path = readdir $dir)) {
		if ($path !~ /^[0-9a-fA-F]+$/) {
			next;
		}
		if (open ($file, '<', ACCESS_PATH.$path)) {
			$unlocktime=<$file>;
			$lasttime=<$file>;
			close($file);
			
			if (($unlocktime !~ /^([0-9]+)$/) or ($lasttime !~ /^([0-9]+)$/)) {
				unlink (ACCESS_PATH.$path);
			}
			elsif ((abs($time-$unlocktime)>$timeout_unlock) or (abs($time-$lasttime)>$timeout_inact)){
				unlink (ACCESS_PATH.$path);
			}
		}
	}
	closedir($dir);
}
